<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useReceiptStore } from '@/stores/receipt'
import { type Ref, inject, ref } from 'vue'
import employeeService from '@/services/employee'
import { useEmployStore } from '@/stores/employee'
import { useMemberStore } from '@/stores/member'
import { usePromotionStore } from '@/stores/Promotion'
import { computed } from 'vue'

const tab = ref(1)
const receiptStore = useReceiptStore()
const authStore = useAuthStore()
const employeeStore = useEmployStore()
const memberStore = useMemberStore()
const promotionsStore = usePromotionStore
function calrecive() {
  receiptStore.receipt.cashBack = receiptStore.receipt?.receivedAmount - receiptStore.receipt?.total
}
function calculateTotalUnits() {
  return receiptStore.receiptItems.reduce((total, item) => total + item.unit, 0)
}
</script>

<template>
  <v-dialog v-model="receiptStore.receiptDialog" max-width="350px">
    <v-card style="background-color: rgb(247, 156, 82); color: white">
      <v-tabs v-model="tab" color="black" background-color="white" align-tabs="center">
        <v-tab :value="1" style="font-weight: bold; font-size: 17px">CASH</v-tab>
        <v-tab :value="2" style="font-weight: bold; font-size: 17px">PROMPTPAY</v-tab>
      </v-tabs>
    </v-card>

    <v-window v-model="tab">
      <v-window-item :value="1">
        <v-card style="background-color: white; height: 300px">
          <v-card-title
            class="kanit-font"
            style="text-align: center; color: white; font-weight: bold"
            >หน้ารับเงิน</v-card-title
          >

          <v-row>
            <v-col style="text-align: center; color: black; font-size: 25px"> ยอดรวม </v-col>
            <v-col> </v-col>
            <v-col style="text-align: center; color: black; font-size: 25px">
              {{ receiptStore.receipt?.total }}
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="1"></v-col>
            <v-col style="text-align: center" cols="10">
              <v-text-field
    v-model="receiptStore.receipt.receivedAmount"
    :rules="[(v) => !!v || 'Field is required']"
    class="mb-2"
    clearable
    label="เงินที่รับมา"
    type="number" 
    style="
        color: black;
        background-color: white;
        border-radius: 25px;
        box-shadow: 0px 4px 8px rgba(0, 0, 0);
    "
    @keydown.enter="calrecive()"
></v-text-field>
            </v-col>
            <v-col cols="1"> </v-col>
          </v-row>
          <v-row>
            <v-col style="text-align: center; color: black"> เงินทอน </v-col>
            <v-col> </v-col>
            <v-col style="text-align: center; color: black">
              {{ receiptStore.receipt.cashBack }}
            </v-col>
          </v-row>
        </v-card>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="black"
            style="background-color: white; font-size: 15px"
            @click="
              () => {
                receiptStore.receiptDialog = false
              }
            "
            class="kanit-font"
            >ปิด</v-btn
          >
          <v-btn
    color="black"
    style="background-color: rgb(247, 156, 82); font-size: 15px"
    @click="
        () => {
          if (receiptStore.receipt.receivedAmount !== 0 && receiptStore.receipt.receivedAmount !== null) {
                receiptStore.endDialog = true;
            }
        }
    "
    class="kanit-font"
    :disabled="receiptStore.receipt.receivedAmount === 0"
>ชําระเงิน</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-window-item>
      <v-window-item :value="2">
        <v-card style="background-color: rgba(180, 143, 81, 1)"> </v-card>
        <v-img src="\public\img\S__26353672.jpg" style="height: 500px"></v-img>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="black"
            style="background-color: white; font-size: 15px"
            @click="
              () => {
                receiptStore.receiptDialog = false
              }
            "
            class="kanit-font"
            >ปิด</v-btn
          >
          <v-btn
            color="black"
            style="background-color: rgb(247, 156, 82); font-size: 15px"
            @click="
              () => {
                receiptStore.endDialog = true
                receiptStore.receipt.paymentType = 'promptpay'
                receiptStore.receipt.receivedAmount = receiptStore.receipt.total
              }
            "
            class="kanit-font"
            >ชําระเงิน</v-btn
          >
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-window-item>
    </v-window>
  </v-dialog>
  <!-- หน้ารับเงิน -->

  <!-- ใบเสร็จ -->
  <v-dialog v-model="receiptStore.endDialog" max-width="420px">
    <div class="receipt">
      <header class="receipt__header">
        <v-img
          src="src\assets\DcoffeeLogo2.png"
          width="100px"
          class="mx-auto my-auto"
          style="max-width: 100%; max-height: 100%"
        ></v-img>
        <p class="receipt__sub" style="line-height: 0; text-align: center">
          รหัสใบเสร็จ : -
        </p>
        <p class="receipt__sub" style="line-height: 0; text-align: center">
          สมาชิก : -
        </p>
        <p class="receipt__sub" style="line-height: 0; text-align: center">
          สาขา : {{ employeeStore.currentEmployee?.branch?.name }}
        </p>
        <v-divider></v-divider>
      </header>
      <v-row>
        <v-col>
          <v-table>
            <!-- using v-for like below will get item and index form the array -->
            <tr v-for="(item,) of receiptStore.receiptItems" :key="item.id">
              <td style="font-size: 10px; text-align: center; padding: 8px;">{{ item.unit }}</td>
              <td style="font-size: 10px; text-align: left; padding: 8px;">{{ item.name }}</td>
              <td style="font-size: 10px; text-align: center">{{ item.price }}</td>
              <td style="font-size: 10px; text-align: center">{{ item.price * item.unit }}</td>
            </tr>
          </v-table>
          <v-divider></v-divider>
          <v-table>
    <tr>
        <td style="font-size: 10px; text-align: left; padding: 4px;">ยอดรวม</td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center">{{ receiptStore.receipt?.totalBefore }}</td>
    </tr>
    <tr>
        <td style="font-size: 10px; text-align: left; padding: 4px;">ส่วนลด</td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center">{{ receiptStore.receipt?.totalDiscount }}</td>
    </tr>
    <tr>
        <td style="font-size: 10px; text-align: left; padding: 4px;">ยอดสุทธิ</td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center">{{ calculateTotalUnits() }} ชิ้น</td>
        <td style="font-size: 10px; text-align: center; padding: 4px;">{{ receiptStore.receipt?.total }}</td>
    </tr>
    <tr>
        <td style="font-size: 10px; text-align: left; padding: 4px;">รับเงิน/เงินทอน</td>
        <td style="font-size: 10px; text-align: center"></td>
        <td style="font-size: 10px; text-align: center">{{ receiptStore.receipt.receivedAmount }}</td>
        <td style="font-size: 10px; text-align: center; padding: 4px;">{{ receiptStore.receipt.cashBack }}</td>
    </tr>
</v-table>

          <v-row>
            <v-col style="text-align: center">
              <v-btn
                color="blue darken-1"
                variant="text"
                @click="
                  () => {
                    receiptStore.endDialog = false
                  }
                "
                >ปิด</v-btn
              >
            </v-col>
            <v-col style="text-align: center">
              <v-btn
                color="blue darken-1"
                variant="text"
                @click="
                  async () => {
                    await receiptStore.saveReceipt()
                    await memberStore.saveAddPointMember()
                    receiptStore.endDialog = false
                    receiptStore.receiptDialog = false
                    receiptStore.clear()
                  }
                "
                >ชําระเงิน</v-btn
              >
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </div>
  </v-dialog>
</template>

<style scoped>
* {
  box-sizing: border-box;
}

body {
  height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  font-family: 'Inter', sans-serif;
  background-color: #ededed;
  margin: 0;
}

.receipt {
  background-color: #fff;
  width: 24rem;
  position: relative;
  padding: 1rem;
  box-shadow: 0 -0.4rem 1rem -0.4rem rgba(0, 0, 0, 0.2);
}

.receipt:after {
  background-image: linear-gradient(135deg, #fff 0.5rem, transparent 0),
    linear-gradient(-135deg, #fff 0.5rem, transparent 0);
  background-position: left-bottom;
  background-repeat: repeat-x;
  background-size: 1rem;
  content: '';
  display: block;
  position: absolute;
  bottom: -1rem;
  left: 0;
  width: 100%;
  height: 1rem;
}

.receipt__header {
  text-align: center;
}

.receipt__sub {
  font-size: 0.7rem;
  color: #666;
  margin: 0.5rem 0 1rem;
}

.receipt__list {
  margin: 2rem 0 1rem;
  padding: 0 1rem;
}

.receipt__list-row {
  display: flex;
  justify-content: space-between;
  margin: 1rem 0;
  position: relative;
}

.receipt__list-row:after {
  content: '';
  display: block;
  border-bottom: 1px dotted rgba(0, 0, 0, 0.15);
  width: 100%;
  height: 100%;
  position: absolute;
  top: -0.25rem;
  z-index: 1;
}

.receipt__item {
  background-color: #fff;
  z-index: 2;
  padding: 0 0.15rem 0 0;
  color: #1f1f1f;
}

.receipt__cost {
  margin: 0;
  padding: 0 0 0 0.15rem;
  background-color: #fff;
  z-index: 2;
  color: #1f1f1f;
}

.receipt__list-row--total {
  border-top: 1px solid #ff619b;
  padding: 1.5rem 0 0;
  margin: 1.5rem 0 0;
  font-weight: 700;
}

.small-font {
  font-size: 11px;
  line-height: 0px;
  text-align: left;
}

.line {
  opacity: 0.5;
  line-height: 0;
}
.kanit-font {
  font-family: 'Kanit', sans-serif; /* Replace 'Kanit' with the actual font name */
}
</style>
